' PROGRAM POKER
' (c) ZarSoft 2023 Pascalated Boriel ZX BASIC
' Written by Ze Oliveira
' Pascalated Boriel (c) 2023 by ZarSoft
' ZX BASIC Compiler (c) 2008 by Boriel

#include <input.bas>  ' number = VAL INPUT(12)
#include <screen.bas> ' SCREEN$ function
#include <attr.bas>   ' ATTR function

'--- Pascalated Boriel ---
#define PROGRAM   REM
#define BEGIN	REM
'#define CONST     CONST
#define VAR       DIM
#define INTEGER   LONG
#define REAL      FLOAT
#define CHAR      STRING ' UBYTE is type integer
'#define STRING    STRING
#define BOOLEAN   UBYTE
#define TYPE      AS
#define BEGIN     REM
'#define WHILE    WHILE
#define REPEAT    DO
#define UNTIL     LOOP UNTIL
#define PROCEDURE  SUB
#define ORD        CODE
'#define MOD        MOD
CONST   TRUE      TYPE BOOLEAN = 1 
CONST   FALSE     TYPE BOOLEAN = 0 

PROGRAM POKER

' CONSTant declarations
CONST black = 0
CONST blue = 1
CONST red = 2
CONST magenta = 3
CONST green = 4
CONST cyan = 5
CONST yellow = 6
CONST white = 7

' VAR - Global variables
VAR PrizeNumber TYPE INTEGER ' prize sequence number
VAR Credit TYPE INTEGER ' available credit
VAR Bet TYPE INTEGER ' bet amount
VAR Prize1(9) TYPE INTEGER ' original prize for each sequence
VAR Prize2(9) TYPE INTEGER ' new prize for each sequence
VAR Deck(52,3) TYPE INTEGER ' 52 cards - ix 0 = removed, ix 1 = suit, ix 2 = value
VAR Hand$ TYPE STRING ' 20chars --- internal key
VAR HandSorted1$ TYPE STRING ' to check sequences
VAR HandSorted2$ TYPE STRING ' to check sequences - Ace converted to high card
VAR Held(6) TYPE BOOLEAN ' held cards
VAR v$ TYPE CHAR ' card value on top
VAR w$ TYPE CHAR ' card value on bottom
VAR s$ TYPE CHAR ' card suit on top
VAR t$ TYPE CHAR ' card suit on bottom
VAR Period TYPE INTEGER = 8

'------------- GERAL ROUTINES -----------------------------------------

PROCEDURE Show_Copyright
VAR addr TYPE INTEGER
VAR i TYPE INTEGER
PRINT AT 23,0;PAPER 0;INK 1;"  (C) 2023 by ZARSOFT ";TAB 31;
'PRINT AT 23,0;PAPER 8;INK 7;Hand$
addr = 2^14+(8+8+8)*8*32-32
FOR i=0 TO LEN Hand$
  POKE addr+i,CODE Hand$
NEXT i
END PROCEDURE

PROCEDURE BIP
BEEP .01,0: BEEP .02,10: BEEP .08,20: BEEP .01,30
RANDOMIZE
END PROCEDURE

'--- KEYBOARD BUFFER ---

VAR BUFFER$ TYPE STRING = ""
VAR LASTKEY$ TYPE STRING = ""

PROCEDURE ScanKey
VAR key$ TYPE STRING = INKEY$ + "#"
IF key$(0) <> LASTKEY$  
  LASTKEY$ = key(0)
  LET BUFFER$ = BUFFER$+key$(0)
ENDIF
END PROCEDURE

FUNCTION GetKey$ TYPE STRING
VAR result$ TYPE STRING
VAR l TYPE INTEGER
LET l = LEN BUFFER$
IF l = 0
  LET result$ = CHR 0
ELSEIF l = 1
  LET result$ = BUFFER$(0)
  BUFFER$ = ""
ELSE
  LET result$ = BUFFER$(0)
  BUFFER$ = BUFFER$( 1 TO )
ENDIF
RETURN result$
END FUNCTION

PROCEDURE WaitKey
  PAUSE 0
  ScanKey
END PROCEDURE

FUNCTION LastKey$ TYPE STRING
RETURN LASTKEY$
END FUNCTION

'------------------------

VAR Clock,Clock0 TYPE INTEGER

PROCEDURE WaitClock
VAR elapsed TYPE INTEGER
REPEAT
  ScanKey
  LET Clock = PEEK 23672
  LET elapsed = Clock-Clock0
  IF elapsed<0 THEN LET elapsed = elapsed+256
UNTIL elapsed >= Period
LET Clock0 = Clock0 + Period: IF Clock0 > 255 THEN LET Clock0 = Clock0 - 256
REM PRINT AT 0,0;INK 2;elapsed;"  ";
END PROCEDURE

'------------------------

PROCEDURE SetSprites
POKE 23606,88 : POKE 23607,251 : REM Sprite
END PROCEDURE

PROCEDURE SetASCII
POKE 23606,0 : POKE 23607,60 : REM ZX Chars
END PROCEDURE

'------------ PRINT CARDS ------------------------------------

FUNCTION CardCol (c TYPE INTEGER) TYPE INTEGER
BEGIN
  RETURN c*6-5
END FUNCTION '-- CardCol --

PROCEDURE Clear_Messages
VAR n TYPE INTEGER
BEGIN
  FOR n = 18 TO 22 
    PRINT AT n,0;" ";TAB 31
  NEXT n
END PROCEDURE '-- Clear_Messages --

PROCEDURE Clear_Cards
VAR n    TYPE INTEGER
BEGIN
  FOR n = 10 TO 17
    PRINT AT n,0;" ";TAB 31
  NEXT n
END PROCEDURE

PROCEDURE Delete_Card (c TYPE INTEGER)
VAR n    TYPE INTEGER
VAR back TYPE STRING
BEGIN
  back = "     "
  FOR n = 10 TO 16 
    PRINT AT n,c*6-5;PAPER 1;back;
  NEXT n
END PROCEDURE '-- Delete_Card --

PROCEDURE Delete_Cards
VAR c TYPE INTEGER
BEGIN
  FOR c = 1 TO 5 
    Delete_Card(c)
  NEXT c
END PROCEDURE

PROCEDURE Print_Back (p TYPE INTEGER)
SetSprites
PRINT AT 10+0,CardCol(p); PAPER 7; INK 2;".....";
PRINT AT 10+1,CardCol(p); PAPER 7; INK 2;".....";
PRINT AT 10+2,CardCol(p); PAPER 7; INK 2;".....";
PRINT AT 10+3,CardCol(p); PAPER 7; INK 2;".....";
PRINT AT 10+4,CardCol(p); PAPER 7; INK 2;".....";
PRINT AT 10+5,CardCol(p); PAPER 7; INK 2;".....";
PRINT AT 10+6,CardCol(p); PAPER 7; INK 2;".....";
SetASCII
END PROCEDURE

PROCEDURE Print_Backs
VAR c TYPE INTEGER
BEGIN
  FOR c = 1 TO 5 
    Print_Back(c)
  NEXT c
END PROCEDURE '-- Print_Backs --

PROCEDURE PrintCard1 (p TYPE INTEGER)
PRINT AT 10+0,CardCol(p);v$;"    ";
PRINT AT 10+1,CardCol(p);"     ";
PRINT AT 10+2,CardCol(p);"     ";
PRINT AT 10+3,CardCol(p);"  "+s$+"  ";
PRINT AT 10+4,CardCol(p);"     ";
PRINT AT 10+5,CardCol(p);"     ";
PRINT AT 10+6,CardCol(p);"    ";w$;
END PROCEDURE

PROCEDURE PrintCard2 (p TYPE INTEGER)
PRINT AT 10+0,CardCol(p);v$;"    ";
PRINT AT 10+1,CardCol(p);"  ";s$;"  ";
PRINT AT 10+2,CardCol(p);"     ";
PRINT AT 10+3,CardCol(p);"     ";
PRINT AT 10+4,CardCol(p);"     ";
PRINT AT 10+5,CardCol(p);"  ";t$;"  ";
PRINT AT 10+6,CardCol(p);"    ";w$;
END PROCEDURE

PROCEDURE PrintCard3 (p TYPE INTEGER)
PRINT AT 10+0,CardCol(p);v$;"    ";
PRINT AT 10+1,CardCol(p);"  ";s$;"  ";
PRINT AT 10+2,CardCol(p);"     ";
PRINT AT 10+3,CardCol(p);"  ";s$;"  ";
PRINT AT 10+4,CardCol(p);"     ";
PRINT AT 10+5,CardCol(p);"  ";t$;"  ";
PRINT AT 10+6,CardCol(p);"    ";w$;
END PROCEDURE

PROCEDURE PrintCard4 (p TYPE INTEGER)
PRINT AT 10+0,CardCol(p);v$;"    ";
PRINT AT 10+1,CardCol(p);" ";s$;" ";s$;" ";
PRINT AT 10+2,CardCol(p);"     ";
PRINT AT 10+3,CardCol(p);"     ";
PRINT AT 10+4,CardCol(p);"     ";
PRINT AT 10+5,CardCol(p);" ";t$;" ";t$;" ";
PRINT AT 10+6,CardCol(p);"    ";w$;
END PROCEDURE

PROCEDURE PrintCard5 (p TYPE INTEGER)
PRINT AT 10+0,CardCol(p);v$;"    ";
PRINT AT 10+1,CardCol(p);" ";s$;" ";s$;" ";
PRINT AT 10+2,CardCol(p);"     ";
PRINT AT 10+3,CardCol(p);"  ";s$;"  ";
PRINT AT 10+4,CardCol(p);"     ";
PRINT AT 10+5,CardCol(p);" ";t$;" ";t$;" ";
PRINT AT 10+6,CardCol(p);"    ";w$;
END PROCEDURE

PROCEDURE PrintCard6 (p TYPE INTEGER)
PRINT AT 10+0,CardCol(p);v$;"    ";
PRINT AT 10+1,CardCol(p);" ";s$;" ";s$;" ";
PRINT AT 10+2,CardCol(p);"     ";
PRINT AT 10+3,CardCol(p);" ";s$;" ";s$;" ";
PRINT AT 10+4,CardCol(p);"     ";
PRINT AT 10+5,CardCol(p);" ";t$;" ";t$;" ";
PRINT AT 10+6,CardCol(p);"    ";w$;
END PROCEDURE

PROCEDURE PrintCard7 (p TYPE INTEGER)
PRINT AT 10+0,CardCol(p);v$;"    ";
PRINT AT 10+1,CardCol(p);" ";s$;" ";s$;" ";
PRINT AT 10+2,CardCol(p);"  ";s$;"  ";
PRINT AT 10+3,CardCol(p);" ";s$;" ";s$;" ";
PRINT AT 10+4,CardCol(p);"     ";
PRINT AT 10+5,CardCol(p);" ";t$;" ";t$;" ";
PRINT AT 10+6,CardCol(p);"    ";w$;
END PROCEDURE

PROCEDURE PrintCard8 (p TYPE INTEGER)
PRINT AT 10+0,CardCol(p);v$;"    ";
PRINT AT 10+1,CardCol(p);" ";s$;" ";s$;" ";
PRINT AT 10+2,CardCol(p);"  ";s$;"  ";
PRINT AT 10+3,CardCol(p);" ";s$;" ";s$;" ";
PRINT AT 10+4,CardCol(p);"  ";t$;"  ";
PRINT AT 10+5,CardCol(p);" ";t$;" ";t$;" ";
PRINT AT 10+6,CardCol(p);"    ";w$;
END PROCEDURE

PROCEDURE PrintCard9 (p TYPE INTEGER)
PRINT AT 10+0,CardCol(p);v$;"    ";
PRINT AT 10+1,CardCol(p);" ";s$;s$;s$;" ";
PRINT AT 10+2,CardCol(p);"     ";
PRINT AT 10+3,CardCol(p);" ";s$;s$;s$;" ";
PRINT AT 10+4,CardCol(p);"     ";
PRINT AT 10+5,CardCol(p);" ";t$;t$;t$;" ";
PRINT AT 10+6,CardCol(p);"    ";w$;
END PROCEDURE

PROCEDURE PrintCard10 (p TYPE INTEGER)
PRINT AT 10+0,CardCol(p);v$;"    ";
PRINT AT 10+1,CardCol(p);" ";s$;" ";s$;" ";
PRINT AT 10+2,CardCol(p);" ";s$;" ";s$;" ";
PRINT AT 10+3,CardCol(p);" ";s$;" ";s$;" ";
PRINT AT 10+4,CardCol(p);" ";t$;" ";t$;" ";
PRINT AT 10+5,CardCol(p);" ";t$;" ";t$;" ";
PRINT AT 10+6,CardCol(p);"    ";w$;
END PROCEDURE

PROCEDURE PrintCard11 (p TYPE INTEGER)
REM jack
PRINT AT 10+0,CardCol(p);v$;" /01";
PRINT AT 10+1,CardCol(p);s$;" 234";
PRINT AT 10+2,CardCol(p);"56789";
PRINT AT 10+3,CardCol(p);":;<=>";
PRINT AT 10+4,CardCol(p);"?@ABC";
PRINT AT 10+5,CardCol(p);"DEF ";t$;
PRINT AT 10+6,CardCol(p);"GHI ";w$;
END PROCEDURE

PROCEDURE PrintCard12 (p TYPE INTEGER)
REM queen
PRINT AT 10+0,CardCol(p);v$;" JKL";
PRINT AT 10+1,CardCol(p);s$;" MNO";
PRINT AT 10+2,CardCol(p);"PQRST";
PRINT AT 10+3,CardCol(p);"UVWXY";
PRINT AT 10+4,CardCol(p);"Z[\\]^";
PRINT AT 10+5,CardCol(p);"_`a ";t$;
PRINT AT 10+6,CardCol(p);"bcd ";w$;
END PROCEDURE

PROCEDURE PrintCard13 (p TYPE INTEGER)
REM king
PRINT AT 10+0,CardCol(p);v$;" efg";
PRINT AT 10+1,CardCol(p);s$;" hij";
PRINT AT 10+2,CardCol(p);"klmno";
PRINT AT 10+3,CardCol(p);"pqrst";
PRINT AT 10+4,CardCol(p);"uvwxy";
PRINT AT 10+5,CardCol(p);"z{| ";t$;
PRINT AT 10+6,CardCol(p);"}~\* ";w$;
END PROCEDURE

PROCEDURE Print_Card (p TYPE INTEGER)
VAR suit TYPE INTEGER
VAR cor TYPE INTEGER
VAR value TYPE INTEGER
SetSprites
LET suit = VAL Hand$((p-1)*2)
LET cor = 0: IF suit>2 THEN LET cor = 2
LET value = CODE Hand$((p-1)*2+1) - CODE "A" + 1
LET s$ = CHR$ ( CODE ("\L") + 2*suit)
LET t$ = CHR$ ( CODE ("\L") + 2*suit+1)
LET v$ = CHR$ ( CODE ("\A") - 1+value)
LET w$ = CHR$ ( CODE (" ") + value)
PAPER 7: INK cor
IF     value = 1 
  PrintCard1(p)
ELSEIF value = 2 
  PrintCard2(p)
ELSEIF value = 3 
  PrintCard3(p)
ELSEIF value = 4
  PrintCard4(p)
ELSEIF value = 5
  PrintCard5(p)
ELSEIF value = 6
  PrintCard6(p)
ELSEIF value = 7
  PrintCard7(p)
ELSEIF value = 8
  PrintCard8(p)
ELSEIF value = 9
  PrintCard9(p)
ELSEIF value = 10
  PrintCard10(p)
ELSEIF value = 11
  PrintCard11(p)
ELSEIF value = 12
  PrintCard12(p)
ELSEIF value = 13
  PrintCard13(p)
ENDIF
PAPER 1: INK 7
SetASCII
END PROCEDURE ' Print_Card

PROCEDURE Print_Cards
VAR p TYPE INTEGER
FOR p=1 TO 5
  Print_Card(p)
NEXT p
END PROCEDURE

'------------ POKER TEST ROUTINES ------------------------------------

FUNCTION Is_Same_Suit (s TYPE STRING) TYPE BOOLEAN
VAR res TYPE BOOLEAN
res = FALSE
 IF s$(0) = s$(2) THEN IF s$(2) = s$(4) THEN IF s$(4) = s$(6) THEN IF s$(6) = s$(8) THEN res = TRUE
RETURN res
END FUNCTION

FUNCTION Is_Sequence (s TYPE STRING) TYPE BOOLEAN
VAR res TYPE BOOLEAN
res = FALSE
IF CODE s$(9) - CODE s$(7) = 1 THEN IF CODE s$(7) - CODE s$(5) = 1 THEN IF CODE s$(5) - CODE s$(3) = 1 THEN IF CODE s$(3) - CODE s$(1) = 1 THEN res = TRUE
RETURN res
END FUNCTION

FUNCTION Check_Jacks_or_Better TYPE BOOLEAN
VAR res TYPE BOOLEAN
BEGIN
  res = FALSE
  ' 2 high sequence  
  IF HandSorted2(1) >= "K" AND HandSorted2$(1) = HandSorted2$(3) THEN res = TRUE
  IF HandSorted2(3) >= "K" AND HandSorted2$(3) = HandSorted2$(5) THEN res = TRUE
  IF HandSorted2(5) >= "K" AND HandSorted2$(5) = HandSorted2$(7) THEN res = TRUE
  IF HandSorted2(7) >= "K" AND HandSorted2$(7) = HandSorted2$(9) THEN res = TRUE
  RETURN res
END FUNCTION '-- Check_Jacks_or_Better --

FUNCTION Check_Two_Pair TYPE BOOLEAN
VAR res TYPE BOOLEAN
BEGIN
  res = FALSE
  ' 2 sequence  + 2 sequence
  IF HandSorted1$(3) = HandSorted1$(5) AND HandSorted1$(7) = HandSorted1$(9) THEN res = TRUE
  IF HandSorted1$(1) = HandSorted1$(3) AND HandSorted1$(7) = HandSorted1$(9) THEN res = TRUE
  IF HandSorted1$(1) = HandSorted1$(3) AND HandSorted1$(5) = HandSorted1$(7) THEN res = TRUE
  RETURN res
END FUNCTION '-- Check_Two_Pair --

FUNCTION Check_Three_of_a_Kind TYPE BOOLEAN
VAR res TYPE BOOLEAN
BEGIN
  res = FALSE
  ' 3 sequence
  IF HandSorted1$(1) = HandSorted1$(5) THEN res = TRUE
  IF HandSorted1$(3) = HandSorted1$(7) THEN res = TRUE
  IF HandSorted1$(5) = HandSorted1$(9) THEN res = TRUE
  RETURN res
END FUNCTION '-- Check_Three_of_a_Kind --

FUNCTION Check_Straight TYPE BOOLEAN
VAR res TYPE BOOLEAN
BEGIN
  res = FALSE
  ' sequence
  IF Is_Sequence(HandSorted1$) THEN res = TRUE
  RETURN res
END FUNCTION '-- Check_Straight --

FUNCTION Check_Flush TYPE BOOLEAN
VAR res TYPE BOOLEAN
BEGIN
  res = FALSE
  ' same suit
  IF Is_Same_Suit(Hand$) THEN res = TRUE
  RETURN res
END FUNCTION '-- Check_Flush --

FUNCTION Check_Full_House TYPE BOOLEAN
VAR res TYPE BOOLEAN
BEGIN
  res = FALSE
  ' 3 sequence  + 2 sequence
  IF HandSorted1$(1) = HandSorted1$(5) AND HandSorted1$(7) = HandSorted1$(9) THEN res = TRUE
  IF HandSorted1$(1) = HandSorted1$(3) AND HandSorted1$(5) = HandSorted1$(9) THEN res = TRUE
  RETURN res
END FUNCTION '-- Check_Full_House --

FUNCTION Check_Four_of_a_Kind TYPE BOOLEAN
VAR res TYPE BOOLEAN
BEGIN
  res = FALSE
  ' 4 sequence 
  IF HandSorted1$(1) = HandSorted1$(7) THEN res = TRUE
  IF HandSorted1$(3) = HandSorted1$(9) THEN res = TRUE
  RETURN res
END FUNCTION '-- Check_Four_of_a_Kind --

FUNCTION Check_Straight_Flush TYPE BOOLEAN
VAR res TYPE BOOLEAN
BEGIN
  res = FALSE
  ' same suit
  IF Is_Same_Suit(Hand$) THEN res = TRUE
  ' sequence 
  IF NOT Is_Sequence(HandSorted1$) THEN res = FALSE
  RETURN res
END FUNCTION '-- Check_Straight_Flush --

FUNCTION Check_Royal_Flush TYPE BOOLEAN
VAR res TYPE BOOLEAN
BEGIN
  res = FALSE
  ' same suit
  IF Is_Same_Suit(Hand$) THEN res = TRUE
  ' sequence with ace
  IF NOT Is_Sequence$( HandSorted2$ ) OR HandSorted2$(9) <> "N" THEN res = FALSE
  RETURN res
END FUNCTION '-- Check_Royal_Flush --

FUNCTION Sort_Values (s$ TYPE STRING) TYPE STRING
VAR res$ TYPE STRING
VAR m,n  TYPE INTEGER
VAR ix   TYPE INTEGER
BEGIN
  res$ = s(0)+s(1)  
  FOR n = 2 TO 9 STEP 2
    ix = n
    FOR m = n-2 TO 0 STEP -2
      IF s$(n+1) < res$(m+1) THEN ix = m
    NEXT m
    res$ = res$(0 TO ix-1) + s$(n)+s$(n+1) + res$(ix TO)
  NEXT n
  RETURN res$
END FUNCTION '-- Sort_Values --

PROCEDURE Verify_Sequence
VAR   n   TYPE INTEGER
VAR i,j TYPE REAL
BEGIN
  ' remove previous highlight
  IF PrizeNumber > 0 THEN PRINT AT 9-PrizeNumber,10;OVER 1;PAPER 8;INK 8;"               "
  ' sort hand
  HandSorted1$ = Sort_Values(Hand$)
  HandSorted2$ = HandSorted1$
  FOR n=1 TO 9 STEP 2
    IF HandSorted2$(n) = "A" THEN HandSorted2$(n) = "N" 
  NEXT n
  HandSorted2$ = Sort_Values(HandSorted2$)
  ' check sequences
  PrizeNumber = 0
  n = 10
  REPEAT
    n = n-1
    IF n = 9 THEN IF Check_Royal_Flush     THEN PrizeNumber = n
    IF n = 8 THEN IF Check_Straight_Flush  THEN PrizeNumber = n
    IF n = 7 THEN IF Check_Four_of_a_Kind  THEN PrizeNumber = n
    IF n = 6 THEN IF Check_Full_House      THEN PrizeNumber = n
    IF n = 5 THEN IF Check_Flush           THEN PrizeNumber = n
    IF n = 4 THEN IF Check_Straight        THEN PrizeNumber = n
    IF n = 3 THEN IF Check_Three_of_a_Kind THEN PrizeNumber = n
    IF n = 2 THEN IF Check_Two_Pair        THEN PrizeNumber = n
    IF n = 1 THEN IF Check_Jacks_or_Better THEN PrizeNumber = n
  UNTIL (n = 1) OR (PrizeNumber <> 0)
  IF PrizeNumber > 0 THEN 
    PRINT AT 9-PrizeNumber,10;FLASH 1;OVER 1;PAPER 8;INK 8;"               "
    LET j=.001
    FOR i=-10 TO 10
      LET j=j-.001*SGN(i)
      BEEP j,10+i
    NEXT i    
  ENDIF  
END PROCEDURE '-- Verify_Sequence --

'------------ AUXILIARY ROUTINES -------------------------------------

FUNCTION Get_Card TYPE STRING
VAR n   TYPE INTEGER
VAR res$ TYPE STRING
BEGIN
  REPEAT
    n = 1 + INT (52*RND)
  UNTIL Deck(n,0) = 0
  Deck(n,0) = 1 ' mark as used
  res$ = CHR$ ( CODE "1" + Deck(n,1) - 1 )
  res$ = res$ + CHR$ ( CODE "A" + Deck(n,2) - 1 )
  RETURN res$
END FUNCTION '-- Get_Card --

PROCEDURE Show_Held
VAR  n  TYPE INTEGER
BEGIN
  FOR n = 1 TO 5 
    PRINT AT 17,6*n-5;
    IF Held(n) THEN PRINT INK yellow;"HELD" ELSE PRINT "    "
  NEXT n
END PROCEDURE '-- Show_Held --

'----------------------------------------------------

PROCEDURE Draw_Cards
VAR  n   TYPE INTEGER
VAR  card$ TYPE STRING
BEGIN
  '-- delete cards without held --
  FOR n = 1 TO 5 
    IF NOT( Held(n) ) THEN Print_Back(n) 
  NEXT n  
  PAUSE 10
  PAUSE 40
  ' get new cards
  FOR n = 1 TO 5 
    IF NOT(Held(n)) THEN 
      card$ = Get_Card
      Hand$( (n-1)*2 ) = card$(0)
      Hand$( (n-1)*2+1 ) = card$(1)
      Print_Card(n) 
      PAUSE 15
    ENDIF  
  NEXT n
  Show_Copyright
  ' clear helds  
  FOR n = 1 TO 5
    Held(n) = FALSE
  NEXT n
  Show_Held
END PROCEDURE '-- Draw_Cards --

PROCEDURE Deal_Cards
VAR  c   TYPE INTEGER
BEGIN
  Hand$ = ""
  FOR c = 1 TO 5 
    Hand$ = Hand$ + Get_Card
    Print_Card(c) 
    PAUSE 15
  NEXT c  
  Show_Copyright
END PROCEDURE '-- Deal_Cards --

PROCEDURE Show_Prizes
VAR n  TYPE INTEGER
VAR st TYPE STRING
BEGIN
  FOR n = 1 TO 9 
    BEGIN
    st = STR$(Prize2(n))
    PRINT AT 9-n,30-LEN(st)-2;"  ";INK 6 + n MOD 2 ;Prize2(n);
  NEXT n
END PROCEDURE '-- Show_Prizes --

PROCEDURE Update_Prizes
VAR   n  TYPE INTEGER
BEGIN
  FOR n = 1 TO 9 
    IF Bet > 0 THEN 
      Prize2(n) = Bet*Prize1(n)
    ELSE 
      Prize2(n) =     Prize1(n)
    ENDIF  
  NEXT n
  Show_Prizes
END PROCEDURE '-- Update_Prizes --

PROCEDURE Show_Credit
VAR  st  TYPE STRING
BEGIN
  st = STR$(Credit)
  PRINT AT 2,7-LEN(st)-2;"  ";INK 4;Credit;
  st = STR$(Bet)
  PRINT AT 4,7-LEN(st)-1;" ";INK yellow;Bet
END PROCEDURE '-- Show_Credit --

PROCEDURE Show_Screen
  ' info
  PRINT AT 1,1;INK green;"CREDIT"
  PRINT AT 4,1;INK yellow;"BET"
  ' card sequences
  PRINT AT 0,9;INK yellow;" ROYAL FLUSH     "
  PRINT AT 1,9;INK white; " STRAIGHT FLUSH  "
  PRINT AT 2,9;INK yellow;" 4 OF A KIND     "
  PRINT AT 3,9;INK white; " FULL HOUSE      "
  PRINT AT 4,9;INK yellow;" FLUSH           "
  PRINT AT 5,9;INK white; " STRAIGHT        "
  PRINT AT 6,9;INK yellow;" 3 OF A KIND     "
  PRINT AT 7,9;INK white; " 2 PAIR          "
  PRINT AT 8,9;INK yellow;" JACKS OR BETTER "
  Show_Credit
END PROCEDURE '-- Show_Screen --

'------------ MAIN ROUTINES ------------------------------------------

PROCEDURE Print_Good_Luck
BEGIN
' GOOD LUCK!

' xxx xxx xxx xx  
' x   x x x x x x 
' x x x x x x x x 
' x x x x x x x x
' xxx xxx xxx xx
  PRINT AT 11,1;INK cyan;"\:'\' \:'\: \:'\: \:'\. "
  PRINT AT 12,1;INK cyan;"\: \: \: \: \: \: \: \: "
  PRINT AT 13,1;INK cyan;"\''\' \''\' \''\' \''\  "
' x   x x xxx x x x 
' x   x x x   x x x
' x   x x x   xx  x
' x   x x x   x x 
' xxx xxx xxx x x x
  PRINT AT 14,9;INK cyan;"\: \  \: \: \:'\' \: \: \: "
  PRINT AT 15,9;INK cyan;"\: \  \: \: \: \  \:'\. \' "
  PRINT AT 16,9;INK cyan;"\''\' \''\' \''\' \' \' \' "
END PROCEDURE '-- Print_Good_Luck --

PROCEDURE Double_Win
BEGIN
  Prize2(PrizeNumber) = 2*Prize2(PrizeNumber)
  Show_Prizes
' x   x xxx x  x
' x   x  x  xx x
' x   x  x  x xx
' x x x  x  x  x
'  x x  xxx x  x
  PRINT AT 14,19;INK yellow;"\: \  \: \':\' \:.\ :"
  PRINT AT 15,19;INK yellow;"\: \. \: \ :\  \: \':"
  PRINT AT 16,19;INK yellow;"\ '\ '\  \''\' \' \ '"
END PROCEDURE '-- Double_Win --

PROCEDURE Double_Big (s TYPE INTEGER)
BEGIN
' xxx  xxx xxx
' x  x  x  x
' xxx   x  x x
' x  x  x  x x
' xxx  xxx xxx
  PRINT AT 14,7;INK cyan;"\:'\'.\ '\:'\ :\''"
  PRINT AT 15,7;INK cyan;"\:'\'.\  \: \ :\ :"
  PRINT AT 16,7;INK cyan;"\''\' \ '\''\ '\''"
  IF s = 1 THEN Double_Win ELSE PrizeNumber = 0
END PROCEDURE '-- Double_Big --

PROCEDURE Double_Small (s TYPE INTEGER)
BEGIN
' xxx x   x  x  x   x
' x   xx xx x x x   x
' xxx x x x xxx x   x
'   x x   x x x x   x
' xxx x   x x x xxx xxx
  PRINT AT 14,7;INK cyan;"\:'\' \:.\ .\: \.'\. \: \  \: \  "
  PRINT AT 15,7;INK cyan;"\''\: \: \' \: \:'\: \: \  \: \  "
  PRINT AT 16,7;INK cyan;"\''\' \' \  \' \' \' \''\' \''\' "
  IF s = -1 THEN Double_Win ELSE PrizeNumber = 0
END PROCEDURE '-- Double_Small --

PROCEDURE Double
VAR  n,s TYPE INTEGER
BEGIN
  Clear_Cards
  Print_Back(1)
  n = 0
  REPEAT
    IF n = 0 THEN 
      PRINT AT 20,2;"\{i7}PUSH \{i6}B\{i7}IG OR \{i6}S\{i7}MALL"
    ELSEIF n = 400 THEN 
      PRINT AT 20,2;"                 "
    ENDIF
    ScanKey
    n = n+1: IF n > 500 THEN n = 0
  UNTIL (LastKey$ = "B") OR (LastKey$ = "S")
  PRINT AT 20,2;"                 "
  BIP
  IF LastKey$ = "B" THEN s = 1 ELSE s = -1
  FOR n = 1 to 6 
    Held(6) = FALSE
  NEXT n  
  Hand$ = Get_Card
  Print_Card(1)
  ' fix ace to high card
  HandSorted2$ = Hand$ 
  IF HandSorted2$(1) = "A" THEN HandSorted2$(1) = "N" 
  ' card "H" = card "8"
  IF HandSorted2$(1) > "H" THEN Double_Big(s)   ' process big
  IF HandSorted2$(1) = "H" THEN PrizeNumber = 0 ' lost
  IF HandSorted2$(1) < "H" THEN Double_Small(s) ' process small
  PAUSE 1*50
  PAUSE 2*50
END PROCEDURE '-- Double --

PROCEDURE Take
VAR n  TYPE INTEGER
VAR st TYPE STRING
BEGIN
  FOR n = Prize2(PrizeNumber)-1 TO 0 STEP -1
    st = STR(n)
    PRINT AT 9-PrizeNumber,30-LEN(st)-2;INK 8;"  ";n;
    Credit = Credit+1
    Show_Credit
    PAUSE 1
  NEXT n
  Prize2(PrizeNumber) = 0
  PAUSE 1*50   
END PROCEDURE '-- Take --

PROCEDURE Double_or_Take
VAR n     TYPE INTEGER
BEGIN
  n = 0
  REPEAT
    IF n = 0 
      PRINT AT 20,2;"\{i6}D\{i7}OUBLE UP BET OR \{i6}T\{i7}AKE SCORE"
    ELSEIF n = 400 
      PRINT AT 20,2;"                           "
    ENDIF
    ScanKey
    IF LastKey$ = "D" THEN BIP: PRINT AT 20,2;"                           ": Double
    IF LastKey$ = "T" THEN BIP
    n = n+1: IF n > 500 THEN n = 0
  UNTIL (LastKey$ = "T") OR (PrizeNumber = 0)
  PRINT AT 20,2;"                           "
  IF PrizeNumber > 0 THEN Take
  Clear_Cards
END PROCEDURE '-- Double_or_Take --

PROCEDURE Hold_Cancel_Draw
VAR    n  TYPE INTEGER
BEGIN
  n = 0
  REPEAT
    IF n = 0 THEN
      PRINT AT 19,15;"\{i7}PUSH HOLD TO   "
      PRINT AT 20,15;"\{i7}HOLD CARD...   "
    ELSEIF n = 200 THEN
      PRINT AT 19,15;"\{i7}PUSH \{i6}C\{i7}ANCEL TO "
      PRINT AT 20,15;"\{i7}CANCEL HOLDS..."
    ELSEIF n = 400 THEN
      PRINT AT 19,15;"\{i7}PUSH \{i6}D\{i7}RAW TO   "
      PRINT AT 20,15;"\{i7}PROCEED.       "
    ELSEIF n = 600 THEN
      PRINT AT 19,15;"               "
      PRINT AT 20,15;"               "
    ENDIF
    ScanKey
    IF LastKey$ >= "1" AND LastKey$ <= "5" THEN BIP: Held(ORD(LastKey$)-ORD("0")) = TRUE: Show_Held 
    IF LastKey$ = "C"  
       BIP
       FOR n = 1 TO 6 
         Held(n) = FALSE
       NEXT n
       Show_Held 
    ENDIF
    IF LastKey$ = "D" THEN BIP
    n = n+1: IF n > 700 THEN n = 0
  UNTIL LastKey$ = "D"
  Clear_Messages
  Draw_Cards
  Verify_Sequence
  IF PrizeNumber > 0 THEN Double_or_Take ELSE PAUSE 3*50
  Bet = 0
  Show_Credit
END PROCEDURE '-- Hold_Cancel_Draw --

'------------------------

PROCEDURE Play_1_TO_20
VAR   valor TYPE INTEGER
BEGIN
  valor = ORD(LastKey$) - ORD("0")
  IF valor = 0 THEN valor = 10
  IF (Bet + valor <= 20) AND (Credit - valor >= 0) THEN
    Credit = Credit-valor
    Bet = Bet+valor
    Show_Credit
    Update_Prizes
  ENDIF
END PROCEDURE '- Play_1_TO_20 -

PROCEDURE Bet1
BEGIN
  IF (Bet < 20) AND (Credit > 0) THEN
    Credit = Credit-1
    Bet = Bet+1
    Show_Credit
    Update_Prizes
  ENDIF
END PROCEDURE '- Bet1 -

PROCEDURE Insert_Coin
BEGIN
  IF LastKey$ = "#" THEN Credit = Credit+100 ELSE Credit = Credit+10
  Show_Credit
END PROCEDURE

PROCEDURE InitGame
VAR   n  TYPE INTEGER
BEGIN
  ' init prizes
  Prize1(1) = 1
  Prize1(2) = 2
  Prize1(3) = 2
  Prize1(4) = 4
  Prize1(5) = 6
  Prize1(6) = 10
  Prize1(7) = 25
  Prize1(8) = 100
  Prize1(9) = 250
  ' clear HELD
  FOR n = 1 TO 6 
    Held(n) = FALSE
  NEXT n  
  ' Clear Bet
  Bet = 0
  ' reset prizes to base prizes
  Update_Prizes
  REM fresh deck
  FOR n = 1 TO 52 
    LET Deck(n,0) = 0 ' all cards are inside deck
  NEXT n
END PROCEDURE '- InitGame -

PROCEDURE  Play_Deal
VAR  n   TYPE INTEGER
BEGIN '---- MainPoker ----
  REPEAT
    InitGame
    Show_Screen
    Print_Backs
    n = 0
    REPEAT
      IF n = 0 THEN 
        PRINT AT 19,15;"\{i7}INSERT COIN"
      ELSEIF n = 200 THEN 
        PRINT AT 20,15;"\{i6}P\{i7}lay \{i6}1\{i7} to \{i6}20\{i7}"
      ELSEIF n = 400 THEN
        PRINT AT 21,15;"\{i7}PUSH \{i6}D\{i7}EAL"
      ELSEIF n = 600 THEN
        PRINT AT 19,15;"            "
        PRINT AT 20,15;"            "
        PRINT AT 21,15;"            "
      ENDIF
      ScanKey
      IF LastKey$ = "$" THEN BIP: Insert_Coin: Show_Credit
      IF LastKey$ = "P" THEN BIP: Bet1
      IF (LastKey$ >= "0") AND (LastKey$ <= "9") THEN BIP: Play_1_TO_20
      IF LastKey$ = "D" THEN BIP
      n = n+1: IF n > 700 THEN n = 0
    UNTIL (LastKey$ = "D") AND (Bet > 0)
    Clear_Messages
    Deal_Cards
    Verify_Sequence
    Hold_Cancel_Draw
  UNTIL Credit = 0
END PROCEDURE '-- Play_Deal --

PROCEDURE Init_Program
VAR c TYPE INTEGER
VAR s TYPE INTEGER
VAR v TYPE INTEGER
BEGIN
  POKE 23658,8 ' caps lock
  Prize1(1) = 1
  Prize1(2) = 2
  Prize1(3) = 2
  Prize1(4) = 4
  Prize1(5) = 6
  Prize1(6) = 10
  Prize1(7) = 25
  Prize1(8) = 100
  Prize1(9) = 250
  REM generate deck
  'DIM Deck(52,2) ' 52 cards, suit, value
  LET c=0
  FOR s=1 TO 4
    FOR v=1 TO 13
      LET c=c+1
      LET Deck(c,0) = 0 ' card is inside deck
      LET Deck(c,1) = s: LET Deck(c,2) = v
    NEXT v
  NEXT s
  Credit = 0
  Bet = 0
END PROCEDURE '- InitProgram -

PROCEDURE  Main_Poker
VAR  n   TYPE INTEGER
BEGIN '---- MainPoker ----
  Init_Program
  BORDER 1: PAPER 1: INK 7: CLS
  Show_Screen
  Update_Prizes
  Show_Copyright
  n = 0
  REPEAT
    IF n = 0 THEN 
      Clear_Cards
      Clear_Messages
      Print_Good_Luck
    ENDIF  
    IF n = 400 THEN 
      PRINT AT 19,15;"\{i7}INSERT COIN"
    ENDIF
    IF n = 800 THEN 
      LASTKEY$ = "#" : BIP: Insert_Coin
    ENDIF
    ScanKey
    n = n+1: IF n > 1000 THEN n = 0
  UNTIL Credit > 0 
  Clear_Cards
  Clear_Messages
  IF Credit THEN Play_Deal
END PROCEDURE '-- Main_Poker --

'------------ MAIN PROGRAM -------------------------------------------

PROCEDURE Test_Sequences
Hand$ = "1J1K1L1M1N"
Verify_Sequence
PRINT "ROYAL FLUSH",Hand$;" ";PrizeNumber 
PRINT
Hand$ = "1A1B1C1D1E"
Verify_Sequence
PRINT "STR FLUSH",Hand$;" ";PrizeNumber 
PRINT
Hand$ = "2I2J2K2L2M"
Verify_Sequence
PRINT "STR FLUSH",Hand$;" ";PrizeNumber 
PRINT
Hand$ = "1B2C3B4B1B"
Verify_Sequence
PRINT "4 OF A KIND ",Hand$;" ";PrizeNumber 
PRINT
Hand$ = "1B2C3B4C1B"
Verify_Sequence
PRINT "FULL HOUSE",Hand$;" ";PrizeNumber 
PRINT
Hand$ = "1B1D1E1G1M"
Verify_Sequence
PRINT "FLUSH",Hand$;" ";PrizeNumber 
PRINT
Hand$ = "1E2D4C1B1F"
Verify_Sequence
PRINT "STRAIGHT",Hand$;" ";PrizeNumber 
PRINT
Hand$ = "1B2B3C4B1G"
Verify_Sequence
PRINT "3 OF A KIND",Hand$;" ";PrizeNumber 
PRINT
Hand$ = "1B2C3C4B1D"
Verify_Sequence
PRINT "2 PAIR",Hand$;" ";PrizeNumber 
PRINT
Hand$ = "1K2A3B4K1C"
Verify_Sequence
PRINT "JACKS OR BETTER",Hand$;" ";PrizeNumber 
PRINT
Hand$ = "1A2A3B4F1C"
Verify_Sequence
PRINT "JACKS OR BETTER",Hand$;" ";PrizeNumber 
PRINT
END PROCEDURE

PROCEDURE The_End
BEGIN
  CLS
  INK 3
  PRINT "POKER"
  PRINT
  INK 4
  PRINT "Written by ZE OLIVEIRA"
  PRINT
  PRINT
  PRINT
  INK 7
  PRINT
  PRINT "(C) 2023 by ZARSOFT"
  PRINT "Pascalated BASIC,Boriel ZX BASIC"
  PRINT
  PRINT AT 21,0;INK 6;"See you later!"
END PROCEDURE

BEGIN
  'PRINT AT 22,0;: Test_Sequences: PAUSE 0
  PAUSE 1*50
  Main_Poker
  PAUSE 50: PAUSE 50: PAUSE 50: PAUSE 50: PAUSE 50
  The_End
END PROGRAM

'------------ END PROGRAM --------------------------------------------

'--------------- CARDS -------------

' 1234567890 JQK
' ABCDEFGHIJ KLMN

' 1 spade
' 2 club
' 3 heart
' 4 diamond

'---------------- BIG/SMALL ----------------

' 234567 8 90JQK1

'----------------  ----------------

